FFT():                         # Start of FFT
################################################
# 		Stage 1-1
################################################
# start of loop for buterfly without multifly
ldi	a, 30
ld      r0, a
addi    a, 20          # r1,r5 = xip = xi+le(20)
ld      r1, a
addi	a, 20
ld	(r7|11), a

Loop1_1:
#########################
ld      a, (r0)
add     a, (r1)
mod     always, shr
ld      x, a            # [x] = temp.real = xi.real + xip.real >> 1

ld      a, (r0)
sub     a, (r1)
mod     always, shr
ld      (r1+!), a         # (r1) = xip.real = xi.real - xip.real >> 1
#-------
ld	a, x
ld	(r0+!), a

ld	a, r1
cmp	a, (r7|11)
bra	n=1, @Loop1_1

################################################
# 		Stage 1-2
################################################
#--- W pointer calculation --- wptr=w+windex-1;
ldi     a, 10		# = wptr
ld      r2, a           # pointer of W.real
ld      r6, a           # pointer of W.imag

#--- Start of loop for "(j)_i"   
#loop_with_MULT_core:
# compute the pointer of xi & xip
ld	-, (r0+!)
ld      a, r0
ld      r4, a

Loop1_2:
#########################
andi    00
ld      x, (r0)      	# x <-- tm.real
ld      y, (r2+!)    	# y <--  u.real
add     a, p
ld      (r3|00), a	# real part
#- xip->imag = add( (mult(tm.real, u.imag), mult(tm.imag, u.real) );
# low storage(xi.real - xip.real) * W_1 (-> W_31) : Imagage
mld	(r6+!), (r0)
add     a, p
ld	(r4+!), a	# imag part
#----------
ld	a, (r3|00)
ld	(r0+!), a

ld	a, r0
#sub	a, (r7|11)
#ld	y, a
cmpi	a, 70
bra	n=1, @Loop1_2

################################################
# 		Stage 2-1-1
################################################
# start of loop for buterfly without multifly
ldi	a, 30
ld      r0, a
addi    a, 10          # r1,r5 = xip = xi+le(10)
ld      r1, a
addi	a, 10
ld	(r7|11), a

Loop2_1_1:
#########################
ld      a, (r0)
add     a, (r1)
mod     always, shr
ld      x, a            # [x] = temp.real = xi.real + xip.real >> 1

ld      a, (r0)
sub     a, (r1)
mod     always, shr
ld      (r1+!), a         # (r1) = xip.real = xi.real - xip.real >> 1
#-------
ld	a, x
ld	(r0+!), a

ld	a, r1
cmp	a, (r7|11)
bra	n=1, @Loop2_1_1

################################################
# 		Stage 2-1-2
################################################
#--- W pointer calculation --- wptr=w+windex-1;
ldi     a, 10		# = wptr
ld      r2, a           # pointer of W.real
ld      r6, a           # pointer of W.imag

#--- Start of loop for "(j)_i"   
#loop_with_MULT_core:
# compute the pointer of xi & xip
ld	-, (r0+!)
ld      a, r0
ld      r4, a

Loop2_1_2:
#########################
andi    00
ld	-, (r2+!)
ld	-, (r6+!)
ld      x, (r0)      	# x <-- tm.real
ld      y, (r2+!)    	# y <--  u.real
add     a, p
ld      (r3|00), a	# real part
#- xip->imag = add( (mult(tm.real, u.imag), mult(tm.imag, u.real) );
# low storage(xi.real - xip.real) * W_1 (-> W_31) : Imagage
mld	(r6+!), (r0)
add     a, p
ld	(r4+!), a	# imag part
#----------
ld	a, (r3|00)
ld	(r0+!), a

ld	a, r0
cmp	a, (r7|11)
bra	n=1, @Loop2_1_2


################################################
# 		Stage 2-2
################################################
# (A+jB)*(C+jD) = (AC-BD) + j(BC+AD)
# A : r0,  B : r4,  C : r2,  D :r6
ld	r4, a
#--------------------  for adjsting W address
ldi	a, 10
ld	r2, a
ld	r6, a
add     a, r4          # r1,r5 = xip = xi+le(10)
ld      r1, a
ld	r5, a
addi	a, 10
ld	(r7|11), a

#-------------------    Not use W, because of calculating real number
ld      a, (r0)
add     a, (r1)
mod	always, shr
ld      (r3|00), a	# temp.real

ld	a, (r4)
add     a, (r5)
mod	always, shr
ld      (r7|00), a      # <[00]> = temp.imag = xi.imag(=0) + xip.imag >> 1

ld      a, (r0)
sub     a, (r1)
mod	always, shr
ld      (r1+!), a      # <[01]> = tm.real = xi.real - xip.real >> 1

ld      a, (r4)
sub     a, (r5)
mod	always, shr
ld      (r5+!), a      # <[01]> = tm.imag = xi.imag - xip.imag >> 1

#--
ld      a, (r3|00)
ld      (r0+!), a         # (r0) = temp.real = xi.real

ld      a, (r7|00)
ld      (r4+!), a         # (r1) = temp.imag = xi.imag

Loop2_2:
#########################
ld	-, (r2+!)
ld	-, (r6+!)
#----
ld      a, (r0)
add     a, (r1)
mod	always, shr
ld      (r3|00), a	# temp.real

ld      a, (r4)
add     a, (r5)
mod	always, shr
ld      (r7|00), a      # <[00]> = temp.imag = xi.imag + xip.imag >> 1

ld      a, (r0)
sub     a, (r1)
mod	always, shr
ld      (r3|01), a      # <[01]> = tm.real = xi.real - xip.real >> 1

ld      a, (r4)
sub     a, (r5)
mod	always, shr
ld      (r7|01), a      # <[01]> = tm.imag = xi.imag - xip.imag >> 1

#- xip->real = sub( (mult(tm.real, u.real), mult(tm.imag, u.imag) );
andi    00
ld      x, (r7|01)      # x <-- tm.imag 
ld      y, (r6)         # y <--  u.imag
add     a, p
ld      (r3|11), a
#---
andi    00
ld      x, (r3|01)      # x <-- tm.real 
ld      y, (r2)         # y <--  u.real
add     a, p
sub	a, (r3|11)
ld      (r1+!), a         # (r1) <-- replaced xip->real

#- xip->imag = add( (mult(tm.real, u.imag), mult(tm.imag, u.real) );
mld	(r6+!), (r3|01)
mpya	(r7|01), (r2+!)
add     a, p
ld      (r5+!), a         # (r1) <-- replaced xip->imag
#--
ld      a, (r3|00)
ld      (r0+!), a         # (r0) = temp.real = xi.real

ld      a, (r7|00)
ld      (r4+!), a         # (r1) = temp.imag = xi.imag

#-----
ld	a, r1
cmp	a, (r7|11)
bra	n=1, @Loop2_2

################################################
# 		Stage 3-1-1
################################################
# start of loop for buterfly without multifly
ldi	a, 30
ld      r0, a
addi    a, 08          # r1,r5 = xip = xi+le(08)
ld      r1, a
addi	a, 08
ld	(r7|11), a

Loop3_1_1:
#########################
ld      a, (r0)
add     a, (r1)
mod     always, shr
ld      x, a            # [x] = temp.real = xi.real + xip.real >> 1

ld      a, (r0)
sub     a, (r1)
mod     always, shr
ld      (r1+!), a         # (r1) = xip.real = xi.real - xip.real >> 1
#-------
ld	a, x
ld	(r0+!), a

ld	a, r1
cmp	a, (r7|11)
bra	n=1, @Loop3_1_1

################################################
# 		Stage 3-1-2
################################################
#--- W pointer calculation --- wptr=w+windex-1;
ldi     a, 10		# = wptr
ld      r2, a           # pointer of W.real
ld      r6, a           # pointer of W.imag

#--- Start of loop for "(j)_i"   
#loop_with_MULT_core:
# compute the pointer of xi & xip
ld	-, (r0+!)
ld      a, r0
ld      r4, a

Loop3_1_2:
#########################
ld	-, (r2+!)
ld	-, (r2+!)
ld	-, (r2+!)
ld	a, r2
ld	r6, a
#---
andi    00
ld      x, (r0)      	# x <-- tm.real
ld      y, (r2+!)    	# y <--  u.real
add     a, p
ld      (r3|00), a	# real part
#- xip->imag = add( (mult(tm.real, u.imag), mult(tm.imag, u.real) );
mld	(r6+!), (r0)
add     a, p
ld	(r4+!), a	# xip.imag part
#----------
ld	a, (r3|00)
ld	(r0+!), a

ld	a, r4
cmp	a, (r7|11)
bra	n=1, @Loop3_1_2

################################################
# 		Stage 3-Loop
################################################
# (A+jB)*(C+jD) = (AC-BD) + j(BC+AD)
# A : r0,  B : r4,  C : r2,  D :r6
Out_Loop3:
ld	r0, a
ld	r4, a
#--------------------  for adjsting W address
addi    a, 08          # r1,r5 = xip = xi+le(08)
ld      r1, a
ld	r5, a
addi	a, 08
ld	(r7|11), a
#---
ldi	a, 10
ld	r2, a
ld	r6, a
#----
ld      a, (r0)
add     a, (r1)
mod	always, shr
ld      (r3|00), a	# temp.real

ld      a, (r4)
add     a, (r5)
mod	always, shr
ld      (r7|00), a      # <[00]> = temp.imag = xi.imag + xip.imag >> 1

ld      a, (r0)
sub     a, (r1)
mod	always, shr
ld      (r1+!), a      # <[01]> = tm.real = xi.real - xip.real >> 1

ld      a, (r4)
sub     a, (r5)
mod	always, shr
ld      (r5+!), a      # <[01]> = tm.imag = xi.imag - xip.imag >> 1

#--
ld      a, (r3|00)
ld      (r0+!), a         # (r0) = temp.real = xi.real

ld      a, (r7|00)
ld      (r4+!), a         # (r1) = temp.imag = xi.imag

In_Loop3:
#########################
ld	-, (r2+!)
ld	-, (r2+!)
ld	-, (r2+!)
ld	a, r2
ld	r6, a
#----
ld      a, (r0)
add     a, (r1)
mod	always, shr
ld      (r3|00), a	# temp.real

ld      a, (r4)
add     a, (r5)
mod	always, shr
ld      (r7|00), a      # <[00]> = temp.imag = xi.imag + xip.imag >> 1

ld      a, (r0)
sub     a, (r1)
mod	always, shr
ld      (r3|01), a      # <[01]> = tm.real = xi.real - xip.real >> 1

ld      a, (r4)
sub     a, (r5)
mod	always, shr
ld      (r7|01), a      # <[01]> = tm.imag = xi.imag - xip.imag >> 1

#- xip->real = sub( (mult(tm.real, u.real), mult(tm.imag, u.imag) );
andi    00
ld      x, (r7|01)      # x <-- tm.imag 
ld      y, (r6)         # y <--  u.imag
add     a, p
ld      (r3|11), a
#---
andi    00
ld      x, (r3|01)      # x <-- tm.real 
ld      y, (r2)         # y <--  u.real
add     a, p
sub	a, (r3|11)
ld      (r1+!), a         # (r1) <-- replaced xip->real

#- xip->imag = add( (mult(tm.real, u.imag), mult(tm.imag, u.real) );
mld	(r6+!), (r3|01)
mpya	(r7|01), (r2+!)
add     a, p
ld      (r5+!), a         # (r1) <-- replaced xip->imag
#--
ld      a, (r3|00)
ld      (r0+!), a         # (r0) = temp.real = xi.real

ld      a, (r7|00)
ld      (r4+!), a         # (r1) = temp.imag = xi.imag

#-----
ld	a, r1
cmp	a, (r7|11)
bra	n=1, @In_Loop3

##################### Out_Loop
cmpi	a, 70
bra	n=1, @Out_Loop3


################################################
# 		Stage 4-1-1
################################################
# start of loop for buterfly without multifly
ldi	a, 30
ld      r0, a
addi    a, 04          # r1,r5 = xip = xi+le(04)
ld      r1, a
addi	a, 04
ld	(r7|11), a

Loop4_1_1:
#########################
ld      a, (r0)
add     a, (r1)
mod     always, shr
ld      x, a            # [x] = temp.real = xi.real + xip.real >> 1

ld      a, (r0)
sub     a, (r1)
mod     always, shr
ld      (r1+!), a         # (r1) = xip.real = xi.real - xip.real >> 1
#-------
ld	a, x
ld	(r0+!), a

ld	a, r1
cmp	a, (r7|11)
bra	n=1, @Loop4_1_1

################################################
# 		Stage 4-1-2
################################################
#--- W pointer calculation --- wptr=w+windex-1;
ldi     a, 10		# = wptr
ld      r2, a           # pointer of W.real
ld      r6, a           # pointer of W.imag

#--- Start of loop for "(j)_i"   
#loop_with_MULT_core:
# compute the pointer of xi & xip
ld	-, (r0+!)
ld      a, r0
ld      r4, a

Loop4_1_2:
#########################
ld	a, r2
addi	a, 07
ld	r2, a
ld	r6, a
#---
andi    00
ld      x, (r0)      	# x <-- tm.real
ld      y, (r2+!)    	# y <--  u.real
add     a, p
ld      (r3|00), a	# real part
#- xip->imag = add( (mult(tm.real, u.imag), mult(tm.imag, u.real) );
mld	(r6+!), (r0)
add     a, p
ld	(r4+!), a	# xip.imag part
#----------
ld	a, (r3|00)
ld	(r0+!), a

ld	a, r4
cmp	a, (r7|11)
bra	n=1, @Loop4_1_2

################################################
# 		Stage 4-Loop
################################################
# (A+jB)*(C+jD) = (AC-BD) + j(BC+AD)
# A : r0,  B : r4,  C : r2,  D :r6
Out_Loop4:
ld	r0, a
ld	r4, a
#--------------------  for adjsting W address
addi    a, 04          # r1,r5 = xip = xi+le(04)
ld      r1, a
ld	r5, a
addi	a, 04
ld	(r7|11), a
#---
ldi	a, 10
ld	r2, a
ld	r6, a
#----
ld      a, (r0)
add     a, (r1)
mod	always, shr
ld      (r3|00), a	# temp.real

ld      a, (r4)
add     a, (r5)
mod	always, shr
ld      (r7|00), a      # <[00]> = temp.imag = xi.imag + xip.imag >> 1

ld      a, (r0)
sub     a, (r1)
mod	always, shr
ld      (r1+!), a      # <[01]> = tm.real = xi.real - xip.real >> 1

ld      a, (r4)
sub     a, (r5)
mod	always, shr
ld      (r5+!), a      # <[01]> = tm.imag = xi.imag - xip.imag >> 1

#--
ld      a, (r3|00)
ld      (r0+!), a         # (r0) = temp.real = xi.real

ld      a, (r7|00)
ld      (r4+!), a         # (r1) = temp.imag = xi.imag

In_Loop4:
#########################
ld	a, r2
addi	a, 07
ld	r2, a
ld	r6, a
#----
ld      a, (r0)
add     a, (r1)
mod	always, shr
ld      (r3|00), a	# temp.real

ld      a, (r4)
add     a, (r5)
mod	always, shr
ld      (r7|00), a      # <[00]> = temp.imag = xi.imag + xip.imag >> 1

ld      a, (r0)
sub     a, (r1)
mod	always, shr
ld      (r3|01), a      # <[01]> = tm.real = xi.real - xip.real >> 1

ld      a, (r4)
sub     a, (r5)
mod	always, shr
ld      (r7|01), a      # <[01]> = tm.imag = xi.imag - xip.imag >> 1

#- xip->real = sub( (mult(tm.real, u.real), mult(tm.imag, u.imag) );
andi    00
ld      x, (r7|01)      # x <-- tm.imag 
ld      y, (r6)         # y <--  u.imag
add     a, p
ld      (r3|11), a
#---
andi    00
ld      x, (r3|01)      # x <-- tm.real 
ld      y, (r2)         # y <--  u.real
add     a, p
sub	a, (r3|11)
ld      (r1+!), a         # (r1) <-- replaced xip->real

#- xip->imag = add( (mult(tm.real, u.imag), mult(tm.imag, u.real) );
mld	(r6+!), (r3|01)
mpya	(r7|01), (r2+!)
add     a, p
ld      (r5+!), a         # (r1) <-- replaced xip->imag
#--
ld      a, (r3|00)
ld      (r0+!), a         # (r0) = temp.real = xi.real

ld      a, (r7|00)
ld      (r4+!), a         # (r1) = temp.imag = xi.imag

#-----
ld	a, r1
cmp	a, (r7|11)
bra	n=1, @In_Loop4

##################### Out_Loop
cmpi	a, 70
bra	n=1, @Out_Loop4

################################################
# 		Stage 5-1-1
################################################
# start of loop for buterfly without multifly
ldi	a, 30
ld      r0, a
addi    a, 02          # r1,r5 = xip = xi+le(02)
ld      r1, a

#########################
ld      a, (r0)
add     a, (r1)
mod     always, shr
ld      x, a            # [x] = temp.real = xi.real + xip.real >> 1

ld      a, (r0)
sub     a, (r1)
mod     always, shr
ld      (r1+!), a         # (r1) = xip.real = xi.real - xip.real >> 1
#-------
ld	a, x
ld	(r0+!), a

#########################
ld      a, (r0)
add     a, (r1)
mod     always, shr
ld      x, a            # [x] = temp.real = xi.real + xip.real >> 1

ld      a, (r0)
sub     a, (r1)
mod     always, shr
ld      (r1+!), a         # (r1) = xip.real = xi.real - xip.real >> 1
#-------
ld	a, x
ld	(r0+!), a

################################################
# 		Stage 5-1-2
################################################
#--- W pointer calculation --- wptr=w+windex-1;
ldi     a, 1f		# = wptr
ld      r2, a           # pointer of W.real
ld      r6, a           # pointer of W.imag

#--- Start of loop for "(j)_i"   
#loop_with_MULT_core:
# compute the pointer of xi & xip
ld	-, (r0+!)
ld      a, r0
ld      r4, a

#---
andi    00
ld      x, (r0)      	# x <-- tm.real
ld      y, (r2)    	# y <--  u.real
add     a, p
ld      (r3|00), a	# real part
#- xip->imag = add( (mult(tm.real, u.imag), mult(tm.imag, u.real) );
mld	(r6), (r0)
add     a, p
ld	(r4+!), a	# xip.imag part
#----------
ld	a, (r3|00)
ld	(r0+!), a

################################################
# 		Stage 5-Loop
################################################
# (A+jB)*(C+jD) = (AC-BD) + j(BC+AD)
# A : r0,  B : r4,  C : r2,  D :r6
ld	a, r0
#--------------------  for adjsting W address
addi    a, 02          # r1,r5 = xip = xi+le(02)
ld      r1, a
ld	r5, a

#####################
ld      a, (r0)
add     a, (r1)
mod	always, shr
ld      (r3|00), a	# temp.real

#ld      a, (r4)
ld      a, (r5)
mod	always, shr
ld      (r7|00), a      # <[00]> = temp.imag = xi.imag + xip.imag >> 1

ld      a, (r0)
sub     a, (r1)
mod	always, shr
ld      (r1+!), a      # <[01]> = tm.real = xi.real - xip.real >> 1

ld      a, (r4)
sub     a, (r5)
mod	always, shr
ld      (r5+!), a      # <[01]> = tm.imag = xi.imag - xip.imag >> 1

#--
ld      a, (r3|00)
ld      (r0+!), a         # (r0) = temp.real = xi.real

ld      a, (r7|00)
ld      (r4+!), a         # (r1) = temp.imag = xi.imag

#########################
ld      a, (r0)
add     a, (r1)
mod	always, shr
ld      (r3|00), a	# temp.real

ld      a, (r4)
add     a, (r5)
mod	always, shr
ld      (r7|00), a      # <[00]> = temp.imag = xi.imag + xip.imag >> 1

ld      a, (r0)
sub     a, (r1)
mod	always, shr
ld      (r3|01), a      # <[01]> = tm.real = xi.real - xip.real >> 1

ld      a, (r4)
sub     a, (r5)
mod	always, shr
ld      (r7|01), a      # <[01]> = tm.imag = xi.imag - xip.imag >> 1

#- xip->real = sub( (mult(tm.real, u.real), mult(tm.imag, u.imag) );
andi    00
ld      x, (r7|01)      # x <-- tm.imag 
ld      y, (r6)         # y <--  u.imag
add     a, p
ld      (r3|11), a
#---
andi    00
ld      x, (r3|01)      # x <-- tm.real 
ld      y, (r2)         # y <--  u.real
add     a, p
sub	a, (r3|11)
ld      (r1+!), a         # (r1) <-- replaced xip->real

#- xip->imag = add( (mult(tm.real, u.imag), mult(tm.imag, u.real) );
mld	(r6), (r3|01)
mpya	(r7|01), (r2)
add     a, p
ld      (r5+!), a         # (r1) <-- replaced xip->imag
#--
ld      a, (r3|00)
ld      (r0+!), a         # (r0) = temp.real = xi.real

ld      a, (r7|00)
ld      (r4+!), a         # (r1) = temp.imag = xi.imag

Loop5:
##################### Loop5
#---
ld	-, (r0+!)
ld	-, (r0+!)
ld	a, r0
ld	r4, a
#--------------------  for adjsting W address
addi    a, 02          # r1,r5 = xip = xi+le(02)
ld      r1, a
ld	r5, a
#----
ld      a, (r0)
add     a, (r1)
mod	always, shr
ld      (r3|00), a	# temp.real
 
ld      a, (r4)
add     a, (r5)
mod	always, shr
ld      (r7|00), a      # <[00]> = temp.imag = xi.imag + xip.imag >> 1

ld      a, (r0)
sub     a, (r1)
mod	always, shr
ld      (r1+!), a      # <[01]> = tm.real = xi.real - xip.real >> 1

ld      a, (r4)
sub     a, (r5)
mod	always, shr
ld      (r5+!), a      # <[01]> = tm.imag = xi.imag - xip.imag >> 1

#--
ld      a, (r3|00)
ld      (r0+!), a         # (r0) = temp.real = xi.real

ld      a, (r7|00)
ld      (r4+!), a         # (r1) = temp.imag = xi.imag

#########################
ld      a, (r0)
add     a, (r1)
mod	always, shr
ld      (r3|00), a	# temp.real

ld      a, (r4)
add     a, (r5)
mod	always, shr
ld      (r7|00), a      # <[00]> = temp.imag = xi.imag + xip.imag >> 1

ld      a, (r0)
sub     a, (r1)
mod	always, shr
ld      (r3|01), a      # <[01]> = tm.real = xi.real - xip.real >> 1

ld      a, (r4)
sub     a, (r5)
mod	always, shr
ld      (r7|01), a      # <[01]> = tm.imag = xi.imag - xip.imag >> 1

#- xip->real = sub( (mult(tm.real, u.real), mult(tm.imag, u.imag) );
andi    00
ld      x, (r7|01)      # x <-- tm.imag 
ld      y, (r6)         # y <--  u.imag
add     a, p
ld      (r3|11), a
#---
andi    00
ld      x, (r3|01)      # x <-- tm.real 
ld      y, (r2)         # y <--  u.real
add     a, p
sub	a, (r3|11)
ld      (r1+!), a         # (r1) <-- replaced xip->real

#- xip->imag = add( (mult(tm.real, u.imag), mult(tm.imag, u.real) );
mld	(r6), (r3|01)
mpya	(r7|01), (r2)
add     a, p
ld      (r5+!), a         # (r1) <-- replaced xip->imag
#--
ld      a, (r3|00)
ld      (r0+!), a         # (r0) = temp.real = xi.real

ld      a, (r7|00)
ld      (r4+!), a         # (r1) = temp.imag = xi.imag

##################### Loop5
ld	a, r1
cmpi	a, 70
bra	n=1, @Loop5

################################################
# 		Stage 6-1
################################################
# start of loop for buterfly without multifly
ldi	r0, 30

#########################	data (0, 1)
ld      a, (r0+!)
add     a, (r0-)
mod     always, shr
ld      x, a            # [x] = temp.real = xi.real + xip.real >> 1

ld      a, (r0+!)
sub     a, (r0)
mod     always, shr
ld      (r0-), a         # (r1) = xip.real = xi.real - xip.real >> 1
#-------
ld	a, x
ld	(r0+!), a
ld	-, (r0+!)

################################################
# 		Stage 6-2
################################################
#------------------------	data (2, 3)  real
ld      a, (r0+!)
add     a, (r0-)
mod     always, shr
ld      x, a            # [x] = temp.real = xi.real + xip.real >> 1

ld      a, (r0+!)
sub     a, (r0)
mod     always, shr
ld      (r0-), a        # (r1) = xip.real = xi.real - xip.real >> 1
#-------
ld	a, x
ld	(r0+!), a
ld	-, (r0+!)

ldi	r4, 33		# imag
#------------------------	data (2, 3)  imag
ld	a, (r4-)
mod	always, shr
ld	x, a

ld	a, (r4+!)
sub	a, (r4)
mod	always, shr
ld	(r4-), a
#---
ld	a, x
ld	(r4+!), a
ld	-, (r4+!)

################################################
# 		Stage 6-Loop
################################################
Loop_6:
#------------------------	data (4, 5)  real  : add 4 point
ld      a, (r0+!)
add     a, (r0-)
mod     always, shr
ld      x, a            # [x] = temp.real = xi.real + xip.real >> 1

ld      a, (r0+!)
sub     a, (r0)
mod     always, shr
ld      (r0-), a         # (r1) = xip.real = xi.real - xip.real >> 1
#-------
ld	a, x
ld	(r0+!), a
ld	-, (r0+!)

#------------------------	data (4, 5)  imag
ld	a, (r4+!)
add	a, (r4-)
mod	always, shr
ld	x, a

ld	a, (r4+!)
sub	a, (r4)
mod	always, shr
ld	(r4-), a
#---
ld	a, x
ld	(r4+!), a
ld	-, (r4+!)

#------------------------	data (6, 7)  real  : add 4 point
ld      a, (r0+!)
add     a, (r0-)
mod     always, shr
ld      x, a            # [x] = temp.real = xi.real + xip.real >> 1

ld      a, (r0+!)
sub     a, (r0)
mod     always, shr
ld      (r0-), a         # (r1) = xip.real = xi.real - xip.real >> 1
#-------
ld	a, x
ld	(r0+!), a
ld	-, (r0+!)

#------------------------	data (6, 7)  imag
ld	a, (r4+!)
add	a, (r4-)
mod	always, shr
ld	x, a

ld	a, (r4+!)
sub	a, (r4)
mod	always, shr
ld	(r4-), a
#---
ld	a, x
ld	(r4+!), a
ld	-, (r4+!)
##########################
ld	a, r0
cmpi	a, 70
bra	n=1, @Loop_6


ld	-,-
